diff -r ee55d0546576 .hgtags
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/.hgtags	Sat Apr 25 19:58:24 2009 +0200
@@ -0,0 +1,2 @@
+b40dd43fc1f27083cf2696c57ec6b907855fb007 2.0-beta1
+4cd407daac0d6fbaa012ef49eec43ffaf32bb207 2.0-beta2
diff -r ee55d0546576 config.lib
--- a/config.lib	Sat Apr 25 12:00:54 2009 +0000
+++ b/config.lib	Sat Apr 25 19:58:24 2009 +0200
@@ -5,7 +5,7 @@
 }
 
 set_default() {
-	released_version=""
+	released_version="IS2.0-beta2"
 
 	ignore_extra_parameters="0"
 	# We set all kinds of defaults for params. Later on the user can override
diff -r ee55d0546576 projects/determineversion.vbs
--- a/projects/determineversion.vbs	Sat Apr 25 12:00:54 2009 +0000
+++ b/projects/determineversion.vbs	Sat Apr 25 19:58:24 2009 +0200
@@ -32,6 +32,7 @@
 		modified = Mid(version, InStrRev(version, Chr(9)) + 1)
 		version  = Mid(version, 1, InStr(version, Chr(9)) - 1)
 	Else
+		version = "IS2.0-beta2"
 		revision = 0
 		modified = 1
 	End If
diff -r ee55d0546576 projects/openttd_vs80.vcproj
--- a/projects/openttd_vs80.vcproj	Sat Apr 25 12:00:54 2009 +0000
+++ b/projects/openttd_vs80.vcproj	Sat Apr 25 19:58:24 2009 +0200
@@ -576,6 +576,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\infrastructure.cpp"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\ini.cpp"
 				>
 			</File>
@@ -1057,6 +1061,14 @@
 			</File>
 			<File
 				RelativePath=".\..\src\industry_type.h"
+				>
+			</File>
+			<File
+				RelativePath=".\..\src\infrastructure.h"
+				>
+			</File>
+			<File
+				RelativePath=".\..\src\infrastructure_func.h"
 				>
 			</File>
 			<File
diff -r ee55d0546576 projects/openttd_vs90.vcproj
--- a/projects/openttd_vs90.vcproj	Sat Apr 25 12:00:54 2009 +0000
+++ b/projects/openttd_vs90.vcproj	Sat Apr 25 19:58:24 2009 +0200
@@ -573,6 +573,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\infrastructure.cpp"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\ini.cpp"
 				>
 			</File>
@@ -1054,6 +1058,14 @@
 			</File>
 			<File
 				RelativePath=".\..\src\industry_type.h"
+				>
+			</File>
+			<File
+				RelativePath=".\..\src\infrastructure.h"
+				>
+			</File>
+			<File
+				RelativePath=".\..\src\infrastructure_func.h"
 				>
 			</File>
 			<File
diff -r ee55d0546576 source.list
--- a/source.list	Sat Apr 25 12:00:54 2009 +0000
+++ b/source.list	Sat Apr 25 19:58:24 2009 +0200
@@ -31,6 +31,7 @@
 gfxinit.cpp
 heightmap.cpp
 highscore.cpp
+infrastructure.cpp
 ini.cpp
 landscape.cpp
 map.cpp
@@ -195,6 +196,8 @@
 highscore.h
 industry.h
 industry_type.h
+infrastructure.h
+infrastructure_func.h
 ini_type.h
 landscape.h
 landscape_type.h
diff -r ee55d0546576 src/aircraft_cmd.cpp
--- a/src/aircraft_cmd.cpp	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/aircraft_cmd.cpp	Sat Apr 25 19:58:24 2009 +0200
@@ -28,6 +28,7 @@
 #include "company_func.h"
 #include "effectvehicle_func.h"
 #include "settings_type.h"
+#include "infrastructure_func.h"
 
 #include "table/strings.h"
 #include "table/sprites.h"
@@ -105,7 +106,7 @@
 	TileIndex vtile = TileVirtXY(v->x_pos, v->y_pos);
 
 	FOR_ALL_STATIONS(st) {
-		if (st->owner != v->owner || !(st->facilities & FACIL_AIRPORT)) continue;
+		if (!(st->facilities & FACIL_AIRPORT) || !IsStationUsageAllowed(st, v)) continue;
 
 		const AirportFTAClass *afc = st->Airport();
 		if (afc->nof_depots == 0 || (
@@ -137,7 +138,7 @@
 
 	FOR_VEHICLE_ORDERS(v, order) {
 		const Station *st = GetStation(order->station);
-		if (st->owner == v->owner && st->facilities & FACIL_AIRPORT) {
+		if (IsStationUsageAllowed(st, v) && st->facilities & FACIL_AIRPORT) {
 			/* If an airport doesn't have a hangar, skip it */
 			if (st->Airport()->nof_depots != 0)
 				return true;
@@ -260,7 +261,7 @@
 	/* to just query the cost, it is not neccessary to have a valid tile (automation/AI) */
 	if (flags & DC_QUERY_COST) return value;
 
-	if (!IsHangarTile(tile) || !IsTileOwner(tile, _current_company)) return CMD_ERROR;
+	if (!AreDepotOperationsAllowed(tile, _current_company, VEH_AIRCRAFT)) return CMD_ERROR;
 
 	/* Prevent building aircraft types at places which can't handle them */
 	if (!CanVehicleUseStation(p1, GetStationByTile(tile))) return CMD_ERROR;
@@ -1621,7 +1622,7 @@
 	/* runway busy or not allowed to use this airstation, circle */
 	if (apc->flags & (v->subtype == AIR_HELICOPTER ? AirportFTAClass::HELICOPTERS : AirportFTAClass::AIRPLANES) &&
 			st->airport_tile != INVALID_TILE &&
-			(st->owner == OWNER_NONE || st->owner == v->owner)) {
+			IsStationUsageAllowed(st, v)) {
 		/* {32,FLYING,NOTHING_block,37}, {32,LANDING,N,33}, {32,HELILANDING,N,41},
 		 * if it is an airplane, look for LANDING, for helicopter HELILANDING
 		 * it is possible to choose from multiple landing runways, so loop until a free one is found */
diff -r ee55d0546576 src/command.cpp
--- a/src/command.cpp	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/command.cpp	Sat Apr 25 19:58:24 2009 +0200
@@ -191,6 +191,7 @@
 DEF_COMMAND(CmdChangeTimetable);
 DEF_COMMAND(CmdSetVehicleOnTime);
 DEF_COMMAND(CmdAutofillTimetable);
+DEF_COMMAND(CmdChangeSharingSetting);
 #undef DEF_COMMAND
 
 /**
@@ -335,6 +336,7 @@
 	{CmdChangeTimetable,                            0}, // CMD_CHANGE_TIMETABLE
 	{CmdSetVehicleOnTime,                           0}, // CMD_SET_VEHICLE_ON_TIME
 	{CmdAutofillTimetable,                          0}, // CMD_AUTOFILL_TIMETABLE
+	{CmdChangeSharingSetting,                       0}, // CMD_CHANGE_SHARING_SETTING
 };
 
 /*!
diff -r ee55d0546576 src/command_type.h
--- a/src/command_type.h	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/command_type.h	Sat Apr 25 19:58:24 2009 +0200
@@ -286,6 +286,7 @@
 	CMD_CHANGE_TIMETABLE,             ///< change the timetable for a vehicle
 	CMD_SET_VEHICLE_ON_TIME,          ///< set the vehicle on time feature (timetable)
 	CMD_AUTOFILL_TIMETABLE,           ///< autofill the timetable
+	CMD_CHANGE_SHARING_SETTING,       ///< change one of the settings for infrastructure sharing
 };
 
 /**
diff -r ee55d0546576 src/company_base.h
--- a/src/company_base.h	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/company_base.h	Sat Apr 25 19:58:24 2009 +0200
@@ -15,6 +15,7 @@
 #include "autoreplace_type.h"
 #include "economy_type.h"
 #include "tile_type.h"
+#include "infrastructure.h"
 
 struct CompanyEconomyEntry {
 	Money income;
@@ -84,6 +85,10 @@
 	uint32 engine_renew_money;
 	uint16 *num_engines; ///< caches the number of engines of each type the company owns (no need to save this)
 
+	byte sharing_delay;                           ///< number of months before new settings go in effect
+	CompanySharingSettingsEntry sharing_current;  ///< settings currently in effect
+	CompanySharingSettingsEntry sharing_future;   ///< future settings, will go in effect after (sharing_delay) months.
+
 	inline bool IsValid() const { return this->name_1 != 0; }
 };
 
diff -r ee55d0546576 src/company_cmd.cpp
--- a/src/company_cmd.cpp	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/company_cmd.cpp	Sat Apr 25 19:58:24 2009 +0200
@@ -173,12 +173,14 @@
 	if (HasBit(1 << EXPENSES_TRAIN_INC    |
 	           1 << EXPENSES_ROADVEH_INC  |
 	           1 << EXPENSES_AIRCRAFT_INC |
-	           1 << EXPENSES_SHIP_INC, cost.GetExpensesType())) {
+	           1 << EXPENSES_SHIP_INC     |
+	           1 << EXPENSES_SHARED_INC, cost.GetExpensesType())) {
 		c->cur_economy.income -= cost.GetCost();
 	} else if (HasBit(1 << EXPENSES_TRAIN_RUN    |
 	                  1 << EXPENSES_ROADVEH_RUN  |
 	                  1 << EXPENSES_AIRCRAFT_RUN |
 	                  1 << EXPENSES_SHIP_RUN     |
+	                  1 << EXPENSES_SHARED_RUN   |
 	                  1 << EXPENSES_PROPERTY     |
 	                  1 << EXPENSES_LOAN_INT, cost.GetExpensesType())) {
 		c->cur_economy.expenses -= cost.GetCost();
@@ -452,11 +454,29 @@
 	c->engine_renew_months = _settings_client.gui.autorenew_months;
 	c->engine_renew_money = _settings_client.gui.autorenew_money;
 
+	/* sharing settings */
+	c->sharing_current.CopyFromGameSettings();
+	c->sharing_future.CopyFromGameSettings();
+
+	if (!_settings_game.sharing.enable_sharing || _settings_game.sharing.individual_allowed) {
+		/* only allow own company */
+		c->sharing_current.allowed_companies = 1 << c->index;
+		c->sharing_future.allowed_companies  = 1 << c->index;
+	} else {
+		/* enable this company in all companies */
+		Company *c;
+		FOR_ALL_COMPANIES(c) {
+			SetBit(c->sharing_current.allowed_companies, c->index);
+			SetBit(c->sharing_future.allowed_companies, c->index);
+		}
+	}
+
 	GeneratePresidentName(c);
 
 	InvalidateWindow(WC_GRAPH_LEGEND, 0);
 	InvalidateWindow(WC_TOOLBAR_MENU, 0);
 	InvalidateWindow(WC_CLIENT_LIST, 0);
+	InvalidateWindowClasses(WC_SHARING_OPTIONS);
 
 	if (is_ai && (!_networking || _network_server)) AI::StartNew(c->index);
 
